package pmicrovenus;

import java.io.Serializable;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToOne;
import javax.swing.JOptionPane;

@Entity
public class CartaSalidaCarcel extends Baraja implements Serializable{
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    private Long id;
      
    int tipo;
      
    @OneToOne(cascade=CascadeType.ALL)
    private Jugador propietario;

    public CartaSalidaCarcel() {
    }
    
    public CartaSalidaCarcel(int tipoCarta) {
        tipo = tipoCarta;
        propietario = null;
    }

    @Override
    public void aplicaAccion(Tablero t) {
  
         String mens;
        if (tipo==Baraja.CARTA_COMUNIDAD) mens ="CARTA COMUNIDAD\n\n" + getEtiqueta();
        else mens ="CARTA SUERTE\n\n" + getEtiqueta();
        String tit = t.getJugadorActual().getNombre();
        JOptionPane.showMessageDialog(null,mens,tit,JOptionPane.INFORMATION_MESSAGE);
        //Accion
        t.getJugadorActual().AddCartasalidacarcel(this);
        
    }

    @Override
    public int getTipoCarta() {
        return tipo;
    }

    @Override
    public String getEtiqueta() {
        return "Vale Salida de la CARCEL";
    }

    public Jugador getPropietario() {
        return propietario;
    }

    public void setPropietario(Jugador propietario) {
        this.propietario = propietario;
    }
       
    @Override
    public boolean isLibre() {
        if (propietario == null) return true;
        return false;
    }

  
    public void aplicaAccion(Jugador j) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
      
      public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof CartaSalidaCarcel)) {
            return false;
        }
        CartaSalidaCarcel other = (CartaSalidaCarcel)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }

    @Override
    public String toString() {
        String res = "CartaSalidaCarcel(" + id + ")";
        return res;
    }
    
}
