package pmicrovenus;

import java.io.Serializable;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToOne;

@Entity
public class Casilla implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="IDJugador")
    private Long id;
    
    private int num;
    private String descripcion;
    private int x;
    private int y;
    private boolean hipotecada;
    private float valorHipoteca;
    
    @OneToOne(cascade=CascadeType.ALL)
    protected Jugador propietario;

    public Casilla() {
        propietario=null;
        hipotecada = false;
        valorHipoteca=0;
    }
    public Casilla(int id, String des, int px, int py) {
        num=id;
        descripcion=des;
        //disponible=true; 
        x=px;
        y=py;
        propietario=null;
        hipotecada = false;
        valorHipoteca=0;
    }
   
    public String getDescripcion() {
        return descripcion;
    }
    public void setDescripcion(String val) {
        this.descripcion = val;
    }

     public int getX() {
        return x;
    }

    public void setX(int x) {
        this.x = x;
    }

    public int getY() {
        return y;
    }

    public void setY(int y) {
        this.y = y;
    }
    
    public int getNum() {
        return this.num;
    }
    public void setNum(int val) {
        this.num = val;
    }

    public Jugador getPropietario() {
        return propietario;
    }
    public void setPropietario(Jugador val) {
        this.propietario = val;
    }
    
    public float getPrecioCompra(){return 0;};    
    public void accion(Tablero t){};
    public void pasa(Jugador j){};
    public float getRenta(){return 0;};   
    public String getColor(){return "";};
    public void addAsociado(Solar asociado){};

    public boolean isHipotecada() {
        return hipotecada;
    }

    public void setHipotecada(boolean hipotecada) {
        this.hipotecada = hipotecada;
    }
    public void hipotecar() {
        
        hipotecada = true;
        propietario.ingreso(getValorHipoteca());
    }
    
    public void deshipotecar() {
        
        hipotecada = false;
        propietario.reintegro(getValorHipoteca() + getValorHipoteca() * 0.1f  );
        
    }

    public float getValorHipoteca() {
        return valorHipoteca;
    }

    public void setValorHipoteca(float valorHipoteca) {
        this.valorHipoteca = valorHipoteca;
    }
    
     
      public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Casilla)) {
            return false;
        }
        Casilla other = (Casilla)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }

    @Override
    public String toString() {
        String res = "Casilla(" + descripcion + ")";
        return res;
    }
    
}
