package pmicrovenus;

import java.awt.Image;
import java.io.Serializable;
import java.util.ArrayList;
import java.awt.Canvas;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import java.net.URL;
import java.util.List;
import java.util.Random;
import java.util.Vector;
import javax.imageio.ImageIO;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.OneToMany;
import javax.persistence.Transient;
import javax.swing.JOptionPane;

@Entity
public class Tablero extends Canvas implements Serializable{
    @Id
    @GeneratedValue(strategy = GenerationType.AUTO)
    @Column(name="IDJugador")
    private Long id;
    
    public static final float SALDO_INICIAL = 2500;
    public static final int TURNOS_CARCEL = 3;
    public static final int PAGO_SALIDA_CARCEL = 100;
    private int turno;
    private int njug;
    private int ronda;
    private int rondasFin;
    private boolean fin;
    
    @Transient 
    public java.awt.Frame formulario;
    
    //Doble buffer
    @Transient
    Image imgInv;
    @Transient
    Graphics grapInv;
    @Transient
    Dimension dimInv;
    
    @OneToMany(cascade=CascadeType.ALL)
    private List<Casilla> casilla= new ArrayList<Casilla>();
    
    @OneToMany(cascade=CascadeType.ALL)
    private List<Jugador> jugador= new ArrayList<Jugador>();
    
    @OneToMany(cascade=CascadeType.ALL)
    private List<Baraja> baraja = new ArrayList<Baraja>();
    
    @OneToMany(cascade=CascadeType.ALL)
    private List<Dado> dado= new ArrayList<Dado>();

    public Tablero() {
    }
        
    public Tablero(ArrayList<Jugador> j) {  
               
        ronda=0;
        rondasFin = -1;
        fin = false;
        setTurno(0);
        formulario = null;
        jugador.addAll(j);
        setNjug(j.size());                  
       int x[]= {0,540,473,426,376,329,277,229,181,132,83,7};
       int y[]= {0,540,471,422,374,326,277,228,180,131,83,7};
        
       //Crea los dados
        dado.add(new Dado());
        dado.add(new Dado());
        
       //Crea las cartas
       baraja.add(0,new CartaSalidaCarcel(Baraja.CARTA_SUERTE));
       baraja.add(1,new CartaSalidaCarcel(Baraja.CARTA_COMUNIDAD));
       baraja.add(2,new CartaIngreso("Te ha tocado la LOTERIA!!! ",150,Baraja.CARTA_SUERTE));
       baraja.add(3,new CartaIngreso("Hacienda Pblica le devuelve dinero ",100,Baraja.CARTA_COMUNIDAD));
       baraja.add(4,new CartaMoverJugador("Avda. Compromiso de Caspe",Baraja.CARTA_SUERTE));
       baraja.add(5,new CartaMoverJugador("Estacion Delicias",Baraja.CARTA_COMUNIDAD));
       baraja.add(6,new CartaReintegro("Debes dinero a la Hacieda Pblica ",120,Baraja.CARTA_SUERTE));
       baraja.add(7,new CartaReintegro("Multa por exceso de velocidad ",100,Baraja.CARTA_COMUNIDAD));
       baraja.add(8,new CartaMoverJugador("Ve a la Carcel",Baraja.CARTA_SUERTE));
       baraja.add(9,new CartaMoverJugador("Ve a la Carcel",Baraja.CARTA_COMUNIDAD));    

       //  Crea las casillas
        casilla.add(0, new Salida(1,"SALIDA", x[1], y[1],100));
        casilla.add(1, new Solar (2,"Avda. Sta. Isabel", x[2], y[1],"MARRON",60,20,20));
        casilla.add(2, new Carta (3,"Caja Comunidad", x[3], y[1],Baraja.CARTA_COMUNIDAD ));
        casilla.add(3, new Solar (4,"Antonio de Leyva", x[4], y[1],"MARRON",60,20,20) );
        casilla.add(4, new Impuesto (5,"Impuesto sobre el capital", x[5], y[1],200) );
        casilla.add(5, new Estacion (6,"Feria oficial de Muestras", x[6], y[1],200,60));
        casilla.add(6, new Solar (7,"Avda. Catalua", x[7], y[1],"CELESTE",100,40,30) );
        casilla.add(7, new Carta (8,"SUERTE", x[8], y[1],Baraja.CARTA_SUERTE) );
        casilla.add(8, new Solar (9,"Avda. Compromiso de Caspe", x[9], y[1],"CELESTE",100,40,30));
        casilla.add(9, new Solar (10,"Avda. San Jose", x[10], y[1],"CELESTE",120,60,50));
        casilla.add(10, new Carcel (11,"Carcel", x[11], y[1]));
        casilla.add(11, new Solar (12,"Avda. Pablo Gargallo", x[11], y[2],"MORAO",140,70,50) );
        casilla.add(12, new Servicio (13,"Compaia de electricidad", x[11], y[3],150,100));   
        casilla.add(13, new Solar (14,"Avda. America", x[11], y[4],"MORAO",140,70,50) );
        casilla.add(14, new Solar (15,"Avda. Navarra", x[11], y[5],"MORAO",160,80,50));
        casilla.add(15, new Estacion (16,"Aeropuerto", x[11], y[6],200,100) );
        casilla.add(16, new Solar (17,"Duquesa Villahermosa", x[11], y[7],"NARANJA",180,90,50));
        casilla.add(17, new Carta (18,"Caja Comunidad", x[11], y[8],Baraja.CARTA_COMUNIDAD) );
        casilla.add(18, new Solar (19,"Maria Zambrano", x[11], y[9],"NARANJA",180,90,50));
        casilla.add(19, new Solar (20,"Conde Aranda", x[11], y[10],"NARANJA",200,100,50) );
        casilla.add(20, new Parking (21,"Parking Gratuito", x[11], y[11]));
        casilla.add(21, new Solar (22,"Villa de la Hispanidad", x[10], y[11],"ROJO",220,110,50));
        casilla.add(22, new Carta (23,"SUERTE", x[9], y[11],Baraja.CARTA_SUERTE));
        casilla.add(23, new Solar (24,"Avda. Tenor Fleta", x[8], y[11],"ROJO",220,110,50));
        casilla.add(24, new Solar (25,"Paseo Cuellar", x[7], y[11],"ROJO",240,120,50));
        casilla.add(25, new Estacion (26,"Estacion Delicias", x[6], y[11],200,100) );
        casilla.add(26, new Solar (27,"Coso", x[5], y[11],"AMARILLO",260,130,50));
        casilla.add(27, new Solar (28,"Cinco de Marzo", x[4], y[11],"AMARILLO",260,130,50));
        casilla.add(28, new Servicio (29,"Compaia de Agua", x[3], y[11],150,100));
        casilla.add(29, new Solar (30,"Alfonso I", x[2], y[11],"AMARILLO",280,140,50));
        casilla.add(30, new IrCarcel (31,"Ve a la Carcel", x[1], y[11]) );
        casilla.add(31, new Solar (32,"Paseo Ruiseores", x[1], y[10],"VERDE",300,150,50));
        casilla.add(32, new Solar (33,"Plaza San Francisco", x[1], y[9],"VERDE",300,150,50));
        casilla.add(33, new Carta (34,"Caja Comunidad", x[1], y[8],Baraja.CARTA_COMUNIDAD));
        casilla.add(34, new Solar (35,"Plaza los Sitios", x[1], y[7],"VERDE",320,160,50));
        casilla.add(35, new Estacion (36,"Recinto Expo", x[1], y[6],220,120) );     
        casilla.add(36, new Carta (37,"SUERTE", x[1], y[5],Baraja.CARTA_SUERTE));
        casilla.add(37, new Solar (38,"Paseo Sagasta", x[1], y[4],"AZUL",350,180,50) );
        casilla.add(38, new Impuesto (39,"IMPUESTO DE LUJO", x[1], y[3],100));
        casilla.add(39, new Solar (40,"Paseo de la Independencia", x[1], y[2],"AZUL",400,200,50));

        
        //Asociamos los Solares del mismo color
        for (int a=0;a<casilla.size();a++){
            for(int b=0;b<casilla.size();b++){
                if ((a!=b)&& (casilla.get(a) instanceof Solar) && (casilla.get(b) instanceof Solar)){
                    if(casilla.get(a).getColor().compareTo(casilla.get(b).getColor()) == 0 ){
                        casilla.get(a).addAsociado((Solar)casilla.get(b));
                        System.out.println("Solar " + casilla.get(a).getDescripcion() + " asociado con " + casilla.get(b).getDescripcion() ); 
                    }
                }
            }
        } 
    }   
   
    public int getTurno() {
        return turno;
    }

    public void setTurno(int turno) {
        this.turno = turno;
    }
     
    public ArrayList<Dado> getDado() {
        ArrayList d = new ArrayList<Dado>();
        d.addAll(dado);
        return d;
    }

    public void setDado(ArrayList<Dado> dado) {
        this.dado = dado;
    }
    
    public List<Casilla> getCasilla() {
        return casilla;
    }
    
    public void setCasilla(ArrayList<Casilla> casilla) {
        this.casilla = casilla;
    }
    
    public List<Jugador> getJugador() {
        return jugador;
    }

    public void setJugador(ArrayList<Jugador> jugador) {
        this.jugador = jugador;
    }

    public int getNjug() {
        return njug;
    }

    public void setNjug(int njug) {
        this.njug = njug;
    }
    
    public Jugador getJugadorActual(){
        return jugador.get(turno);
    }
    
    public int getIndexJugadorActual(){
        return turno;
    }
    
    public Casilla getCasillaPorNombre(String n){
      for(int i=0;i<casilla.size();i++) {
        Casilla c = casilla.get(i);
        if(c.getDescripcion().equals(n)) {
                return casilla.get(i);
            }
    }
    return null;	
    }
    
    public int getNumSolaresPorColor(String color) {
         int conta=0;
         for(int i=0;i<casilla.size();i++) {
           Casilla c = casilla.get(i);
           if(c instanceof Solar){
               Solar s=(Solar) c;
               if(s.getColor().equals(color)){
                    conta++;
               }
           }
        }return conta;    
     }
    
    //Siguiente turno
    public void siguiente(){
        turno = (turno + 1) % njug; 
        if (turno == 0 ) setRonda(getRonda() + 1);
        if (rondasFin!=-1){
            if (ronda == rondasFin)
                setFin(true);
        }
//        turno = turno % njug;
    }
  
    // Mover Numero de posiciones PASANDO POR SALIDA y Jugando Accion 
    public Casilla moverJS(int suma, Casilla cas){
         int pos, nPos;
         Jugador j = getJugadorActual();
         
         pos=(cas.getNum())-1;
         nPos = (pos + suma) % (40);
         
         j.setPosicion(casilla.get(nPos));
        
        if (nPos<pos && nPos!=0) {                  //Paso por Salida?
            getCasillaPorNombre("SALIDA").pasa(j);
        }  
        casilla.get(nPos).accion(this);   //Jugar Accion 
        
        if(j.getCogeCarta()>0) this.cogerCarta(j);  //Coge carta??
              
        if (j.isEncarcelado()) this.encarcelarJugadorActual();   //Est enarcelado??
        
         return casilla.get((nPos));
    }
     
   
    // Mover Numero de posiciones PASANDO POR SALIDA y Jugando Accion 
    public void moverJS(int suma) {
        int pos,nPos;
        Jugador j = getJugadorActual();
       //  Actualizar Posicion
        pos = j.getPosicion().getNum()-1;
        nPos = (pos + suma) % (40);
        j.setPosicion(casilla.get(nPos));
        
        if (nPos<pos && nPos!=0) {                  //Paso por Salida?
              getCasillaPorNombre("SALIDA").pasa(j);
        } 
        
                    
        casilla.get(nPos).accion(this);   //Jugar Accion 
        
        if(j.getCogeCarta()>0) this.cogerCarta(j);  //Coge carta??
              
        if (j.isEncarcelado()) this.encarcelarJugadorActual();   //Est enarcelado??
    } 
    
    
     //Mover a Casilla c PASANDO POR SALIDA y sin Jugar Accion 
     public void moverNJS(Casilla c) {
          int pos, nPos;
         
          nPos=(c.getNum())-1;
          pos=getJugadorActual().getPosicion().getNum()-1;

         getJugadorActual().setPosicion(c);
        
        if (nPos<pos && nPos!=0) {                  //Paso por Salida?
             getCasillaPorNombre("SALIDA").pasa(getJugadorActual());
        }  
        //casilla.get(nPos).accion(getJugadorActual());   //Jugar Accion 
        
       
    } 
    
     //Mover a Casilla c PASANDO POR SALIDA y Jugar Accion 
     public void moverJS(Casilla c) {
          int pos, nPos;
         
          nPos=(c.getNum())-1;
          pos=getJugadorActual().getPosicion().getNum()-1;
           
         getJugadorActual().setPosicion(c);
        
        if (nPos<pos && nPos!=0) {                  //Paso por Salida?
             getCasillaPorNombre("SALIDA").pasa(getJugadorActual());
        }  
        casilla.get(nPos).accion(this);   //Jugar Accion 
        
       
    } 
    
     public ArrayList<Baraja> getCartasDisponibles(int tipoCarta){
        ArrayList<Baraja> cartas = new ArrayList();
        int tipo = tipoCarta;
        //Vble. cartas = cartas disponibles
        for(int i = 0;i<baraja.size();i++){
            if(baraja.get(i).getTipoCarta() == tipo){// Si es del mismo tipo(comunidad/caja)
                if(baraja.get(i) instanceof CartaSalidaCarcel){//Si es Carta Salida
                    if (baraja.get(i).isLibre()){
                        cartas.add(baraja.get(i));
                    }
                }else{//Si es otra carta
                    cartas.add(baraja.get(i));
                }
            }
        }
        return cartas;
     }
     
    public void cogerCarta (Jugador j){
       int tipo = j.getCogeCarta(); 
       ArrayList<Baraja> cartas;// = new ArrayList();
       Baraja cartaElegida;
       
       cartas =  getCartasDisponibles(tipo);
       Random r =new Random();
       int ind =(r.nextInt(cartas.size()));
       cartaElegida = cartas.get(ind);
       System.out.println(this.getJugadorActual().getNombre() + " coge carta " + cartaElegida.getClass().getName());
       
       cartaElegida.aplicaAccion(this);
       j.setCogeCarta(0);
    }
       
    public void encarcelarJugadorActual(){
        this.getJugadorActual().setPosicion(this.getCasillaPorNombre("Carcel"));
        this.getJugadorActual().setEncarcelado(TURNOS_CARCEL);
    }
    
    public void tirar() {
        
        Dado d1=getDado().get(0);
        Dado d2=getDado().get(1);
        Jugador j = getJugadorActual();
     //Tirar dados
        d1.tirar();
        d2.tirar();
        
        comprobarDobles();
        
    }
    
    public void comprobarDobles() {
        Dado d1=getDado().get(0);
        Dado d2=getDado().get(1);
        
        Jugador j = getJugadorActual();
        int tirada = (d1.getValorCara())+(d2.getValorCara());
        
        //Si dobles 
            if (d1.getValorCara()==d2.getValorCara()) {
                j.incDobles();
               if ((j.getDobles()==3)){//Si van 3 dobles
                    String mens = "Has sacado 3 dobles seguidos, vas directamente a la CARCEL!!!";
                    String tit = j.getNombre();
                    JOptionPane.showMessageDialog(null,mens,tit,JOptionPane.INFORMATION_MESSAGE);
                    
                    encarcelarJugadorActual();
                    j.setDobles(0);

               }else{//Si no van 3 dobles
                    String mens = "Has sacado doble " + this.getDado().get(0).getValorCara() + ", TIRAS DE NUEVO!!!";
                    String tit = j.getNombre();
                    JOptionPane.showMessageDialog(null,mens,tit,JOptionPane.INFORMATION_MESSAGE);
                    moverJS(tirada);
               }                
            }else{//Si no dobles
                
                moverJS(tirada);
                j.setDobles(0);
            }
            
        
    }
       
    public void tirarDesdeCarcel() {
        Dado d1=getDado().get(0);
        Dado d2=getDado().get(1);
        Jugador j = getJugadorActual();
     //Tirar dados
           d1.tirar();
           d2.tirar();
         
        comprobarDoblesCarcel();  
    }
    
    public void comprobarDoblesCarcel() {
        Dado d1=getDado().get(0);
        Dado d2=getDado().get(1);
        Jugador j = getJugadorActual();
        int tirada = (d1.getValorCara())+(d2.getValorCara());
        
        //Si dobles 
        if (d1.getValorCara()==d2.getValorCara()) {
            String mens = "Has sacado doble " + this.getDado().get(0).getValorCara() + ", SALES DE LA CARCEL!!!";
            String tit = j.getNombre();
            JOptionPane.showMessageDialog(null,mens,tit,JOptionPane.INFORMATION_MESSAGE);
            
            j.setEncarcelado(0);//Sale de la carcel
            moverJS(tirada);
       }else{//Si no dobles
            j.setEncarcelado(j.getEncarcelado()-1);
            
            String mens = "Has sacado un "+this.getDado().get(0).getValorCara()+" y un "+this.getDado().get(1).getValorCara()+"\nSigues en la carcel, te quedan " + j.getEncarcelado() + " turnos para salir" ;
            String tit = j.getNombre();
            JOptionPane.showMessageDialog(null,mens,tit,JOptionPane.INFORMATION_MESSAGE);
            }
    }
   
    public BufferedImage loadImage(String nombre) {
        URL url=null;
        try {
                url = getClass().getResource(nombre);
                return ImageIO.read(url);
        } catch (Exception e) {
                System.out.println("No se pudo cargar la imagen " + nombre +" de "+ url );
                System.out.println("El error fue : "+e.getClass().getName()+" "+e.getMessage());
                System.exit(0);
                return null;
        }
    }

    @Override
    public void paint(Graphics g) {

       if (grapInv == null ){
           this.imgInv = createImage(610,610);
           this.grapInv = this.imgInv.getGraphics();
       }
        //Pintamos el tablero en el inicio de las coordenadas
        BufferedImage mono = loadImage("monopoly.gif");
        grapInv.drawImage(mono, 0, 0,this);

        for(int i=0;i<jugador.size();i++){
            Jugador j=jugador.get(i);//Pintamos al Jugador
            grapInv.drawImage(loadImage(j.getFicha().getTipo()), j.getPosicion().getX(),j.getPosicion().getY(),this);
            Vector<Casilla> prop = (Vector<Casilla>) j.getTodasPropiedadesV();
            for(int k =0;k<prop.size();k++){
                
                if (prop.get(k) instanceof Solar){
                    Solar s=(Solar) prop.get(k);
                    if(s.getNCasas()<5){//Pintamos los edificios
                        for (int a=0;a<s.getNCasas();a++){
                        int t=(a*10);
                        grapInv.drawImage(loadImage(j.getFicha().getCasa()), prop.get(k).getX()+t,prop.get(k).getY(),this);
                        }
                    }else{
                        if (s.getNCasas()==5){
                        grapInv.drawImage(loadImage(j.getFicha().getHotel()), prop.get(k).getX()+20,prop.get(k).getY(),this);
                        }
                    }
                }
                //Pintamos las propiedades
               grapInv.drawImage(loadImage(j.getFicha().getMiniFicha()), prop.get(k).getX(),prop.get(k).getY(),this);
            }
        }
        //Pintamos los dados
        int d1 = this.getDado().get(0).getValorCara();
        int d2 = this.getDado().get(1).getValorCara();
        String cara1="";
        String cara2 ="";
        switch(d1){
            case 1:
                cara1 = "uno.gif";
                break;
            case 2:
                cara1 = "dos.gif";
                break;
            case 3:
                cara1 = "tres.gif";
                break;
            case 4:
                cara1 = "cuatro.gif";
                break;
            case 5:
                cara1 = "cinco.gif";
                break;
            case 6:
                cara1 = "seis.gif";
                break;
                
        }
        switch(d2){
            case 1:
                cara2 = "uno.gif";
                break;
            case 2:
                cara2 = "dos.gif";
                break;
            case 3:
                cara2 = "tres.gif";
                break;
            case 4:
                cara2 = "cuatro.gif";
                break;
            case 5:
                cara2 = "cinco.gif";
                break;
            case 6:
                cara2 = "seis.gif";
                break;
                
        }
        if (!(cara1.compareTo("")==0)||!(cara2.compareTo("")==0)){
            grapInv.drawImage(loadImage(cara1), 350, 300, this);
            grapInv.drawImage(loadImage(cara2), 450, 300, this);
        }
        
        
      g.drawImage(this.imgInv,0,0,this); 
    }	

    @Override
    public void update(Graphics g) {
         paint(g);
     }

   
    public Long getId() {
        return this.id;
    }

    public void setId(Long id) {
        this.id = id;
    }
    
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.id != null ? this.id.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tablero)) {
            return false;
        }
        Tablero other = (Tablero)object;
        if (this.id != other.id && (this.id == null || !this.id.equals(other.id))) return false;
        return true;
    }

    @Override
    public String toString() {
        String res = "Tablero(" + id + ")";
        return res;
    }

    public int getRonda() {
        return ronda;
    }

    public void setRonda(int ronda) {
        this.ronda = ronda;
    }

    public int getRondasFin() {
        return rondasFin;
    }

    public void setRondasFin(int rondasFin) {
        this.rondasFin = rondasFin;
    }

    public boolean isFin() {
        return fin;
    }

    public void setFin(boolean fin) {
        this.fin = fin;
    }
    
      
}